Subject: Re: bug#55231: [PATCH v1] initrd: Allow extra search paths with‘initrd-extra-module-paths’

From: Ludovic Courtès <[email-masked]>
Date: Mon, 17 Feb 2025 11:07:07 +0100

Maxim Cournoyer <[email-masked]> skribis:

>>> +          ;; DRV2 is *not* available as a substitute, since it has drv1 as
>>> +          ;; input, and the non-substitutability is viral to avoid
>>> +          ;; distributing non-substitutable items that could have become
>>> +          ;; embedded, for example in an initrd.

Also, there are legitimate cases where the current semantics (where X is
not distributable but its dependents are) are what’s expected and relied
on.

We have some of these in HPC packages but also, more importantly, lots
of them in Guix proper: ‘imported-files/derivation’, ‘gexp->script’,
etc. produce non-substitutable derivations, but we definitely want its
dependents to be substitutable (otherwise ‘guix pull’ and large parts of
Guix System would not have substitutes, for instance.)

Ludo’.